poj 1836 Alignment dp

7 篇文章 0 订阅

Alignment
Time Limit: 1000MS Memory Limit: 30000K
Total Submissions: 14488 Accepted: 4696

Description

In the army, a platoon is composed by n soldiers. During the morning inspection, the soldiers are aligned in a straight line in front of the captain. The captain is not satisfied with the way his soldiers are aligned; it is true that the soldiers are aligned in order by their code number: 1 , 2 , 3 , . . . , n , but they are not aligned by their height. The captain asks some soldiers to get out of the line, as the soldiers that remain in the line, without changing their places, but getting closer, to form a new line, where each soldier can see by looking lengthwise the line at least one of the line's extremity (left or right). A soldier see an extremity if there isn't any soldiers with a higher or equal height than his height between him and that extremity. 

Write a program that, knowing the height of each soldier, determines the minimum number of soldiers which have to get out of line. 

Input

On the first line of the input is written the number of the soldiers n. On the second line is written a series of n floating numbers with at most 5 digits precision and separated by a space character. The k-th number from this line represents the height of the soldier who has the code k (1 <= k <= n). 

There are some restrictions: 
• 2 <= n <= 1000 
• the height are floating numbers from the interval [0.5, 2.5] 

Output

The only line of output will contain the number of the soldiers who have to get out of the line.

Sample Input

8
1.86 1.86 1.30621 2 1.4 1 1.97 2.2

Sample Output

4

题意:去掉最少的人使得每个人都能看到两头中的一头,就是等于人是三角形排列的。


双端求lis 再从头到尾枚举一遍

#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <vector>
#include <queue>
#include <stack>
#include <set>
#include <map>
using namespace std;
#define Max 1024
double p[Max];
int d1[Max],d2[Max],n;
int main()
{
    cin>>n;
    for(int i=1;i<=n;i++)
        cin>>p[i];
    int res=0;d1[1]=1;
        d2[1]=1;
    for(int i=1;i<=n;i++)
    {
        int m=0;
        for(int j=1;j<i;j++)
        {
            if(p[j]<p[i]&&m<d1[j]) m=d1[j];
        }
        d1[i]=m+1;
    }
    for(int i=n;i>=1;i--)
    {
        int m=0;
        for(int j=n;j>i;j--)
        {
            if(p[j]<p[i]&&m<d2[j]) m=d2[j];
        }
        d2[i]=m+1;
    }
    for(int i=1;i<n;i++)
    {
        for(int j=i+1;j<=n;j++)
        res=max(res,d1[i]+d2[j]);
    }
    cout<<n-res<<endl;
    return 0;
}


还有一种就是枚举端点的位置再判断两头的最长不下降子序列,得用n*logn的时间复杂度的lis

随时更新一个不下降的子序列,对于每个新加入的元素,二分查找他的位置,加入

#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <vector>
#include <queue>
#include <stack>
#include <set>
#include <map>
using namespace std;
#define Max 1024
double p[Max];
double lis[Max],lds[Max];
int n;
int search_lis(double a[],int left,int right,double val)
{
    int mid=(left+right)/2;
    int r=right;int l=left;
    while(l<r)
    {
        if(a[mid]==val) return mid;
        else if(a[mid]>val)
        {
            r=mid;
            mid=(l+r)/2;
        }
        else
        {
            l=mid+1;
            mid=(l+r)/2;
        }
    }
    return l;
}

int search_lds(double a[],int left,int right,double val)
{
    int mid=(left+right)/2;
    int r=right;int l=left;
    while(l<r)
    {
        mid=(l+r)/2;
        if(a[mid]==val) return mid;
        else if(a[mid]<val)
        {
            r=mid;
        }
        else
        {
            l=mid+1;
        }
    }
    return l;
}

int main()
{
    cin>>n;
    int res=0;
    for(int i=1;i<=n;i++) cin>>p[i];
    for(int m=1;m<=n;m++)
    {
        int len_lis=1;
        for(int i=1;i<=m;i++)
        {
            lis[len_lis]=23333;
            int k=search_lis(lis,1,len_lis,p[i]);
            if(k==len_lis) len_lis++;lis[k]=p[i];
        }
        len_lis--;
        int len_lds=1;
        lis[m]=233;
        for(int i=m+1;i<=n;i++)
        {
            lis[m+len_lds]=-1;
            int k=search_lds(lis,m,m+len_lds,p[i]);
            if(k==m+len_lds) {len_lds++;}lis[k]=p[i];
        }
        len_lds--;
        res=max(res,len_lis+len_lds);
    }
    cout<<n-res<<endl;
    return 0;
}





  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
题目描述 给出一个$n\times m$的矩阵,每个位置上有一个非负整数,代表这个位置的海拔高度。一开始时,有一个人站在其中一个位置上。这个人可以向上、下、左、右四个方向移动,但是只能移动到海拔高度比当前位置低或者相等的位置上。一次移动只能移动一个单位长度。定义一个位置为“山顶”,当且仅当从这个位置开始移动,可以一直走到海拔高度比它低的位置上。请问,这个矩阵中最多有多少个“山顶”? 输入格式 第一行两个整数,分别表示$n$和$m$。 接下来$n$行,每行$m$个整数,表示整个矩阵。 输出格式 输出一个整数,表示最多有多少个“山顶”。 样例输入 4 4 3 2 1 4 2 3 4 3 5 6 7 8 4 5 6 7 样例输出 5 算法1 (递归dp) $O(nm)$ 对于这道题,我们可以使用递归DP来解决,用$f(i,j)$表示以$(i,j)$为起点的路径最大长度,那么最后的答案就是所有$f(i,j)$中的最大值。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码 算法2 (动态规划) $O(nm)$ 动态规划的思路与递归DP类似,只不过转移方程和实现方式有所不同。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值